/* PlugsManager.c generated by valac 0.39.7, the Vala compiler
 * generated from PlugsManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2014 Switchboard Developers (http://launchpad.net/switchboard)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include "config.h"
#include <stdlib.h>
#include <string.h>
#include <gmodule.h>


#define SWITCHBOARD_TYPE_PLUGS_MANAGER (switchboard_plugs_manager_get_type ())
#define SWITCHBOARD_PLUGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManager))
#define SWITCHBOARD_PLUGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerClass))
#define SWITCHBOARD_IS_PLUGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER))
#define SWITCHBOARD_IS_PLUGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUGS_MANAGER))
#define SWITCHBOARD_PLUGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerClass))

typedef struct _SwitchboardPlugsManager SwitchboardPlugsManager;
typedef struct _SwitchboardPlugsManagerClass SwitchboardPlugsManagerClass;
typedef struct _SwitchboardPlugsManagerPrivate SwitchboardPlugsManagerPrivate;

#define SWITCHBOARD_TYPE_PLUG (switchboard_plug_get_type ())
#define SWITCHBOARD_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlug))
#define SWITCHBOARD_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))
#define SWITCHBOARD_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))

typedef struct _SwitchboardPlug SwitchboardPlug;
typedef struct _SwitchboardPlugClass SwitchboardPlugClass;
enum  {
	SWITCHBOARD_PLUGS_MANAGER_0_PROPERTY,
	SWITCHBOARD_PLUGS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* switchboard_plugs_manager_properties[SWITCHBOARD_PLUGS_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL,
	SWITCHBOARD_PLUGS_MANAGER_NUM_SIGNALS
};
static guint switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_NUM_SIGNALS] = {0};

struct _SwitchboardPlugsManager {
	GObject parent_instance;
	SwitchboardPlugsManagerPrivate * priv;
};

struct _SwitchboardPlugsManagerClass {
	GObjectClass parent_class;
};

struct _SwitchboardPlugsManagerPrivate {
	GeeLinkedList* plugs;
};

typedef SwitchboardPlug* (*SwitchboardPlugsManagerRegisterPluginFunction) (GModule* module);

static gpointer switchboard_plugs_manager_parent_class = NULL;
static SwitchboardPlugsManager* switchboard_plugs_manager_plugs_manager;
static SwitchboardPlugsManager* switchboard_plugs_manager_plugs_manager = NULL;

GType switchboard_plugs_manager_get_type (void) G_GNUC_CONST;
GType switchboard_plug_get_type (void) G_GNUC_CONST;
#define SWITCHBOARD_PLUGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerPrivate))
SwitchboardPlugsManager* switchboard_plugs_manager_get_default (void);
static SwitchboardPlugsManager* switchboard_plugs_manager_new (void);
static SwitchboardPlugsManager* switchboard_plugs_manager_construct (GType object_type);
static void switchboard_plugs_manager_find_plugins (SwitchboardPlugsManager* self,
                                             GFile* base_folder);
static void switchboard_plugs_manager_load (SwitchboardPlugsManager* self,
                                     const gchar* path);
static void switchboard_plugs_manager_register_plug (SwitchboardPlugsManager* self,
                                              SwitchboardPlug* plug);
const gchar* switchboard_plug_get_code_name (SwitchboardPlug* self);
gboolean switchboard_plugs_manager_has_plugs (SwitchboardPlugsManager* self);
GeeCollection* switchboard_plugs_manager_get_plugs (SwitchboardPlugsManager* self);
static void switchboard_plugs_manager_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 112 "PlugsManager.c"
}


SwitchboardPlugsManager*
switchboard_plugs_manager_get_default (void)
{
	SwitchboardPlugsManager* result = NULL;
	SwitchboardPlugsManager* _tmp0_;
	SwitchboardPlugsManager* _tmp2_;
	SwitchboardPlugsManager* _tmp3_;
#line 26 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = switchboard_plugs_manager_plugs_manager;
#line 26 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp0_ == NULL) {
#line 127 "PlugsManager.c"
		SwitchboardPlugsManager* _tmp1_;
#line 27 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp1_ = switchboard_plugs_manager_new ();
#line 27 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (switchboard_plugs_manager_plugs_manager);
#line 27 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		switchboard_plugs_manager_plugs_manager = _tmp1_;
#line 135 "PlugsManager.c"
	}
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = switchboard_plugs_manager_plugs_manager;
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	result = _tmp3_;
#line 28 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return result;
#line 145 "PlugsManager.c"
}


static SwitchboardPlugsManager*
switchboard_plugs_manager_construct (GType object_type)
{
	SwitchboardPlugsManager * self = NULL;
	GeeLinkedList* _tmp0_;
	GFile* base_folder = NULL;
	GFile* _tmp1_;
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self = (SwitchboardPlugsManager*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = gee_linked_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (self->priv->plugs);
#line 39 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self->priv->plugs = _tmp0_;
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = g_file_new_for_path (PLUGS_DIR);
#line 40 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	base_folder = _tmp1_;
#line 41 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_find_plugins (self, base_folder);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (base_folder);
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return self;
#line 174 "PlugsManager.c"
}


static SwitchboardPlugsManager*
switchboard_plugs_manager_new (void)
{
#line 38 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return switchboard_plugs_manager_construct (SWITCHBOARD_TYPE_PLUGS_MANAGER);
#line 183 "PlugsManager.c"
}


static void
switchboard_plugs_manager_load (SwitchboardPlugsManager* self,
                                const gchar* path)
{
	GModule* module = NULL;
	GModule* _tmp0_;
	GModule* _tmp1_;
	void* function = NULL;
	GModule* _tmp3_;
	void* _tmp4_ = NULL;
	void* _tmp5_;
	SwitchboardPlugsManagerRegisterPluginFunction register_plugin = NULL;
	void* _tmp6_;
	SwitchboardPlug* plug = NULL;
	SwitchboardPlugsManagerRegisterPluginFunction _tmp7_;
	GModule* _tmp8_;
	SwitchboardPlug* _tmp9_;
	SwitchboardPlug* _tmp10_;
	GModule* _tmp11_;
	SwitchboardPlug* _tmp12_;
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (path != NULL);
#line 45 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (g_module_supported () == FALSE) {
#line 46 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_error ("PlugsManager.vala:46: Switchboard is not supported by this system!");
#line 215 "PlugsManager.c"
	}
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = g_module_open (path, G_MODULE_BIND_LAZY);
#line 49 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	module = _tmp0_;
#line 50 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = module;
#line 50 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp1_ == NULL) {
#line 225 "PlugsManager.c"
		const gchar* _tmp2_;
#line 51 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp2_ = g_module_error ();
#line 51 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("PlugsManager.vala:51: %s", _tmp2_);
#line 52 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_module_close0 (module);
#line 52 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 235 "PlugsManager.c"
	}
#line 56 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp3_ = module;
#line 56 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_module_symbol (_tmp3_, "get_plug", &_tmp4_);
#line 56 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	function = _tmp4_;
#line 57 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp5_ = function;
#line 57 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp5_ == NULL) {
#line 58 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("PlugsManager.vala:58: get_plug () not found in %s", path);
#line 59 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_module_close0 (module);
#line 59 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 253 "PlugsManager.c"
	}
#line 62 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp6_ = function;
#line 62 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	register_plugin = (SwitchboardPlugsManagerRegisterPluginFunction) _tmp6_;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp7_ = register_plugin;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp8_ = module;
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp9_ = _tmp7_ (_tmp8_);
#line 63 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	plug = _tmp9_;
#line 64 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp10_ = plug;
#line 64 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (_tmp10_ == NULL) {
#line 65 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("PlugsManager.vala:65: Unknown plugin type for %s !", path);
#line 66 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (plug);
#line 66 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_module_close0 (module);
#line 66 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 279 "PlugsManager.c"
	}
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp11_ = module;
#line 68 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_module_make_resident (_tmp11_);
#line 69 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp12_ = plug;
#line 69 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_register_plug (self, _tmp12_);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (plug);
#line 44 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_module_close0 (module);
#line 293 "PlugsManager.c"
}


static void
switchboard_plugs_manager_find_plugins (SwitchboardPlugsManager* self,
                                        GFile* base_folder)
{
	GFileInfo* file_info = NULL;
	GError * _inner_error_ = NULL;
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (base_folder != NULL);
#line 73 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	file_info = NULL;
#line 309 "PlugsManager.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp0_ = g_file_enumerate_children (base_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error_);
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		enumerator = _tmp0_;
#line 75 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 319 "PlugsManager.c"
			goto __catch0_g_error;
		}
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		while (TRUE) {
#line 324 "PlugsManager.c"
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFile* file = NULL;
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp10_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp2_ = enumerator;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error_);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp1_ = _tmp3_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_g_object_unref0 (enumerator);
#line 346 "PlugsManager.c"
				goto __catch0_g_error;
			}
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp4_ = _tmp1_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp1_ = NULL;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_g_object_unref0 (file_info);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			file_info = _tmp4_;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp5_ = file_info;
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (!(_tmp5_ != NULL)) {
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_g_object_unref0 (_tmp1_);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				break;
#line 365 "PlugsManager.c"
			}
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp6_ = file_info;
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp7_ = g_file_info_get_name (_tmp6_);
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp8_ = g_file_get_child (base_folder, _tmp7_);
#line 77 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			file = _tmp8_;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_tmp10_ = file_info;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (g_file_info_get_file_type (_tmp10_) == G_FILE_TYPE_REGULAR) {
#line 379 "PlugsManager.c"
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp11_ = file_info;
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp12_ = g_file_info_get_content_type (_tmp11_);
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp9_ = g_content_type_equals (_tmp12_, "application/x-sharedlib");
#line 388 "PlugsManager.c"
			} else {
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp9_ = FALSE;
#line 392 "PlugsManager.c"
			}
#line 79 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			if (_tmp9_) {
#line 396 "PlugsManager.c"
				GFile* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp13_ = file;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp14_ = g_file_get_path (_tmp13_);
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp15_ = _tmp14_;
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				switchboard_plugs_manager_load (self, _tmp15_);
#line 80 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_g_free0 (_tmp15_);
#line 410 "PlugsManager.c"
			} else {
				GFileInfo* _tmp16_;
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				_tmp16_ = file_info;
#line 81 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
				if (g_file_info_get_file_type (_tmp16_) == G_FILE_TYPE_DIRECTORY) {
#line 417 "PlugsManager.c"
					GFile* _tmp17_;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
					_tmp17_ = file;
#line 82 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
					switchboard_plugs_manager_find_plugins (self, _tmp17_);
#line 423 "PlugsManager.c"
				}
			}
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_g_object_unref0 (file);
#line 76 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
			_g_object_unref0 (_tmp1_);
#line 430 "PlugsManager.c"
		}
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (enumerator);
#line 434 "PlugsManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		err = _inner_error_;
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp18_ = g_file_get_path (base_folder);
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp19_ = _tmp18_;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp20_ = err;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_tmp21_ = _tmp20_->message;
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_warning ("PlugsManager.vala:86: Unable to scan plugs folder %s: %s\n", _tmp19_, _tmp21_);
#line 86 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_free0 (_tmp19_);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_error_free0 (err);
#line 462 "PlugsManager.c"
	}
	__finally0:
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		_g_object_unref0 (file_info);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 475 "PlugsManager.c"
	}
#line 72 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (file_info);
#line 479 "PlugsManager.c"
}


static void
switchboard_plugs_manager_register_plug (SwitchboardPlugsManager* self,
                                         SwitchboardPlug* plug)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
#line 90 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (self != NULL);
#line 90 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_if_fail (plug != NULL);
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = switchboard_plug_get_code_name (plug);
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = _tmp0_;
#line 91 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_debug ("PlugsManager.vala:91: %s registered", _tmp1_);
#line 92 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = self->priv->plugs;
#line 92 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, plug)) {
#line 93 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
		return;
#line 507 "PlugsManager.c"
	}
#line 94 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp3_ = self->priv->plugs;
#line 94 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, plug);
#line 95 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_signal_emit (self, switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL], 0, plug);
#line 515 "PlugsManager.c"
}


gboolean
switchboard_plugs_manager_has_plugs (SwitchboardPlugsManager* self)
{
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 98 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = self->priv->plugs;
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = _tmp1_;
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	result = !_tmp2_;
#line 99 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return result;
#line 538 "PlugsManager.c"
}


GeeCollection*
switchboard_plugs_manager_get_plugs (SwitchboardPlugsManager* self)
{
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 102 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp0_ = self->priv->plugs;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_tmp2_ = _tmp1_;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	result = (GeeCollection*) _tmp2_;
#line 103 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	return result;
#line 561 "PlugsManager.c"
}


static void
switchboard_plugs_manager_class_init (SwitchboardPlugsManagerClass * klass)
{
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	g_type_class_add_private (klass, sizeof (SwitchboardPlugsManagerPrivate));
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	G_OBJECT_CLASS (klass)->finalize = switchboard_plugs_manager_finalize;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL] = g_signal_new ("plug-added", SWITCHBOARD_TYPE_PLUGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SWITCHBOARD_TYPE_PLUG);
#line 576 "PlugsManager.c"
}


static void
switchboard_plugs_manager_instance_init (SwitchboardPlugsManager * self)
{
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self->priv = SWITCHBOARD_PLUGS_MANAGER_GET_PRIVATE (self);
#line 585 "PlugsManager.c"
}


static void
switchboard_plugs_manager_finalize (GObject * obj)
{
	SwitchboardPlugsManager * self;
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManager);
#line 34 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	_g_object_unref0 (self->priv->plugs);
#line 21 "/builddir/build/BUILD/switchboard-2.3.0/lib/PlugsManager.vala"
	G_OBJECT_CLASS (switchboard_plugs_manager_parent_class)->finalize (obj);
#line 599 "PlugsManager.c"
}


GType
switchboard_plugs_manager_get_type (void)
{
	static volatile gsize switchboard_plugs_manager_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_plugs_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SwitchboardPlugsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_plugs_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardPlugsManager), 0, (GInstanceInitFunc) switchboard_plugs_manager_instance_init, NULL };
		GType switchboard_plugs_manager_type_id;
		switchboard_plugs_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SwitchboardPlugsManager", &g_define_type_info, 0);
		g_once_init_leave (&switchboard_plugs_manager_type_id__volatile, switchboard_plugs_manager_type_id);
	}
	return switchboard_plugs_manager_type_id__volatile;
}



